// ------------------------------------------------------------ //<>//
// -------------------- grales --------------------------------
// ----------------------------------------------------------------
// General functions that cannot be arranged in any other tab -----
// ----------------------------------------------------------------

// -------------------------------------------------------------------
// Loading the fonts
PFont numerosTotales;
PFont titles;
PFont roundTitles;
PFont roundTitlesAlias;
PFont speakFont;
// -------------------------------------------------------------------
// -------------------------------------------------------------------
void loadFonts() {

  titles = loadFont( "data/fonts/FuturaKoyu-48.vlw" ); 
  numerosTotales = loadFont( "data/fonts/FuturaDemiC-12.vlw" );
  roundTitles = loadFont("data/fonts/MyriadPro-Semibold-9.vlw");
  roundTitlesAlias = createFont("MyriadPro-Semibold", 9, true);
  speakFont = createFont("MyriadPro-Regular-9", 10, true);
}
// -------------------------------------------------------------------
// -------------------------------------------------------------------

void mostrarDataViz() {
  // ********************************************************************
  // 3D *****************************************************************
  // 0. Let's show the HUGE BOX
  pushMatrix();
  translate(width/2, height/2, -10);
  noFill();
  stroke(255);
  box(1600, 1000, 1300);
  popMatrix();
  // ********************************************************************
  // ********************************************************************

  // 1. We re-arrange the data of years
  int columnas = 8; //years
  int renglones = 12; // months
  int cantidad = columnas*renglones;

  // 2. Define width and height
  float margenHor = 60;
  float margenVer = 100;
  float ancho = width-(margenHor*2); // Like 150 per margin
  float alto = height-(margenVer*2);
  float interAncho = ancho/(columnas+1);
  float interAlto = alto/(renglones+1);

  // 3. We draw a grid
  for (int i = 0; i < renglones; i++) {
    for (int j = 0; j < columnas; j++) {

      // We define x, y properties
      float x = interAncho*j;
      float y = interAlto*i;
      float z = random(100);

      // We translate the grid
      x += margenHor*2;
      y+= margenVer*2;

      // We try to determine the data for this cell
      //int dato = 0;
      /*
      if (ordenRenglones) {
       dato = datosR [(i+1)+(j*12) ][ 3 ];//(12*j)+1
       } else {
       dato = datos[ (i+1)+(j*12) ][ 3 ];//(12*j)+1
       }
       */
      int dato = columna3[(i+1)+(j*12) ];


      // Obtenemos el deseo para el color
      float deseo = map( dato, noMenor, noMayor, 1, 0 );
      fill(getColor(deseo));
      // We draw a square
      stroke(0, 0, 0, 160);
      //noFill();
      strokeWeight(0.4);
      rectMode(CORNER);
      if (reticula)rect(x, y, interAncho, interAlto);

      // ********************************************************************
      // 3D *****************************************************************
      // Vamos con el deseo del "z"
      z = map( deseo, 0, 1, zMin, zMax );
      // z = map( j, 0, totalCols, zMin, zMax )/4;
      // z = map( i, 0, totalRows, zMin, zMax );
      // Va el rect en 3D
      pushMatrix();
      translate( x, y, z );
      //box(ancho/2, alto/2, 30); 
      popMatrix();



      // Experimento de particles !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      float cantidadParticulas = map( deseo, 1, 0, particulasMin, particulasMax );
      cantidadParticulas = dato;
      for (int k = 0; k < cantidadParticulas; k++) {
        float divisionAncho = 3; // 3 funciona
        float divisionAlto = 3; // 3 funciona
        float posX = random( x-(ancho/divisionAncho), x+(ancho/divisionAncho) );
        float posY = random( y-(alto/divisionAlto), y+(alto/divisionAlto) );
        float posZ = random(z-4, z+4);
        noStroke();
        pushMatrix();
        translate( posX, posY, posZ );
        float tamanoCaja = 5; 

        //box(tamanoCaja, tamanoCaja, tamanoCaja*deseo);
        box(tamanoCaja, tamanoCaja, tamanoCaja);
        popMatrix();
      }


      // ********************************************************************
      // ********************************************************************

      // We draw the text
      textFont(titles, 90);
      fill(255, 255, 255, 190);
      if (texto)
        text(dato, x+(interAncho/2), y+(interAlto/2), z);
    }
  }
  //Primera leyenda del 2006
  //println("Primera del 2006 es: "+datos[1][3]);
  //print("Cero modulo 12 es: "+0%12);

  //4. Leyendas renglones ( MESES )
  for (int i = 0; i < renglones; i++) {
    // We define height
    float y = interAlto*i;
    y+= margenVer*2;

    fill(255, 255, 255, 190);
    textAlign(RIGHT);
    textFont(titles, 30);
    text(meses[i], margenHor+30, y +(interAlto/2), 0);
  }


  //5. Leyendas columnas ( ANOS )
  int startingYear = 2006;
  for (int j = 0; j < columnas; j++) {
    // We define X
    float x = interAncho*j;
    x+= margenHor*2;

    fill(0, 0, 0, 190);
    fill(255);
    textAlign(CENTER);
    textFont(titles, 40);
    text(years[j], x +(interAncho/2), margenVer+90, 0);
  }

  // 6. Title
  fill(0, 0, 0, 120);
  textAlign(CENTER);
  textFont(titles, 16.08);
  text("INTEREST IN AUTOBIOGRAPHIES OVER THE YEARS", width/2, margenVer+10);
  textFont(titles, 10.08);
  text("(lighter cells means higher activity)", width/2, margenVer+30);
}

// --------------------------------------------------------------------------------------------------
void reordenarColumnas() {
  // Reordenar los headers....

  // 1. Primero sumamos los anos
  // Tenemos 8 anos
  int [] suma = new int[8]; // Aqu'i guardaremos las sumas

  for (int i = 0; i < 8; i++ ) { // son 8 anos
    int puntoInicio = (12*i)+1;
    for (int j = 0; j<12; j++) {//Son doce meses
      //suma[i] += datosOriginales[ puntoInicio+j][3]; // Siempre columna 3
      suma[i] += columna3Original[ puntoInicio+j]; // La columna 3 separada
    }
    println("Suma "+yearsO[i]+" "+i+" = "+suma[i]);
  }


  // 2. Ahora vamos a reodernarlos (y as'i saber en qu'e posici'on los queremos)
  int [] sumaNueva = suma; //Creamos un nuevo arreglo para obtener los nuevos valores
  sumaNueva = sort(sumaNueva);

  int sumaTotal = 0;
  for (int l = 0; l < sumaNueva.length; l++) {
    println(sumaNueva[l]);
    sumaTotal += sumaNueva[l];
  }
  println(" >> >> >> SUMA TOTAL TOTAL TOTAL: "+sumaTotal);


  // 3. Encontraremos ahora la posicion para cada punto de la suma
  int posicionAnterior = 0;
  int posicionNueva = 0;

  for (int i = 0; i<suma.length; i++) {

    // a. Encontramos donde esta
    for (int j = 0; j < suma.length; j++) {      
      // Si son iguales, quiere decir que ya encontramos la posicion donde debe de ir
      if ( sumaNueva[i] == suma[j]) {
        posicionAnterior = j;
        posicionNueva = i;
      }
    }

    println("La suma nueva "+posicionNueva+" "+sumaNueva[posicionNueva]+" antes estaba en anterior "+posicionAnterior+" "+suma[posicionAnterior]);
    // b. Aplicamos las operaciones de re-ordenamiento, sabemos que son 12 elementos.
    for (int k = 0; k < 12; k++) { // 12 porque son doce meses
      //
      int renglonAInsertar = (12*posicionNueva) +1;
      int renglonDeDondeTomar = (12*posicionAnterior) +1;

      // Primero con los datos
      // datos[k+renglonAInsertar][3] = datosOriginales[ k+renglonDeDondeTomar ][3];
      columna3[k+renglonAInsertar] = columna3Original[ k+renglonDeDondeTomar ];
    }

    // C ahora con los anos
    years[posicionNueva] = yearsO[ posicionAnterior ];
  } // Termina for en siguiente curly bracket --->

  arrayCopy(columna3, columna3Columnas);
}


// --------------------------------------------------------------------------------------------------

void reordenarRenglones() {
  // Esta function lee los datos (no los originales)

  // 1. Primero sumamos los meses
  // Tenemos 12 meses
  int [] suma = new int[12]; // Aqu'i guardaremos las sumas

  for (int i = 0; i < 12; i++ ) { // son 12 meses
    int puntoInicio = i+1;
    for (int j = 0; j<8; j++) {//Son 8 anos
      println("quiero sumar ="+puntoInicio+(j*12)+" vs max rows= "+totalRows);
      //suma[i] += datos[ puntoInicio+(j*12)][3]; // Siempre columna 3
      suma[i] += columna3[ puntoInicio+(j*12)]; // Siempre columna 3
    }
    println("Suma meses "+meses[i]+" "+i+" = "+suma[i]);
  }


  // 2. Ahora vamos a reodernarlos (y as'i saber en qu'e posici'on los queremos)
  int [] sumaNueva = suma; //Creamos un nuevo arreglo para obtener los nuevos valores
  sumaNueva = sort(sumaNueva);

  for (int l = 0; l < sumaNueva.length; l++) {
    println("Sema Nueva meses = "+l+" "+sumaNueva[l]);
  }
  for (int l = 0; l < sumaNueva.length; l++) {
    println("Sema VIEJA meses = "+l+" "+suma[l]);
  }

  // 3. Encontraremos ahora la posicion para cada punto de la suma
  int posicionAnterior = 0;
  int posicionNueva = 0;

  for (int i = 0; i<suma.length; i++) {//12 meses

    // a. Encontramos donde esta
    for (int j = 0; j < suma.length; j++) {      
      // Si son iguales, quiere decir que ya encontramos la posicion donde debe de ir
      if ( sumaNueva[i] == suma[j]) {
        posicionAnterior = j;
        posicionNueva = i;
      }
    }

    println("MESES > La suma nueva "+posicionNueva+" "+sumaNueva[posicionNueva]+" antes estaba en anterior "+posicionAnterior+" "+suma[posicionAnterior]);
    // b. Aplicamos las operaciones de re-ordenamiento, sabemos que son 12 elementos.
    int [][] datosT = new int [totalRows][totalCols];
    // datosT =datos;
    for (int k = 0; k < 8; k++) { // 8* veces, una por ano
      //
      // int renglonAInsertar = (posicionNueva+1)+(k*12);
      //int renglonDeDondeTomar = (posicionAnterior+1)+(k*12);
      int renglonDeDondeTomar = posicionAnterior+1;
      int renglonAInsertar = posicionNueva+1;
      renglonDeDondeTomar += (12*k);
      renglonAInsertar += (12*k);

      //println(">> >> >> Inserto k="+k+" tomar: "+renglonDeDondeTomar+" insertar: "+renglonAInsertar);
      //println(k+" - Insertar: "+renglonAInsertar+" vs totalRows "+totalRows +" ( ant= "+renglonDeDondeTomar+" )");
      // Primero con los datos
      // println("tomare el: "+datos[ renglonDeDondeTomar ][3]);
      //datosT[renglonAInsertar][3] = datosOriginales[ renglonDeDondeTomar ][3];
      columna3[renglonAInsertar] = columna3Columnas[ renglonDeDondeTomar ]; // COlumna 3 nuevo m'etodo
      //println("ahora esta: "+datosT[renglonAInsertar][3]);
    }

    datosR = datosT;
    // C ahora con los anos
    meses[posicionNueva] = mesesO[ posicionAnterior ];
  } // Termina for en siguiente curly bracket --->
}
